SDL_mouse.h File Reference
`#include <SDL3/SDL_stdinc.h>`
`#include <SDL3/SDL_error.h>`
`#include <SDL3/SDL_surface.h>`
`#include <SDL3/SDL_video.h>`
`#include <SDL3/SDL_begin_code.h>`
`#include <SDL3/SDL_close_code.h>`
Include dependency graph for SDL_mouse.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | SDL_CursorFrameInfo

## Macros

#define | SDL_BUTTON_LEFT 1
#define | SDL_BUTTON_MIDDLE 2
#define | SDL_BUTTON_RIGHT 3
#define | SDL_BUTTON_X1 4
#define | SDL_BUTTON_X2 5
#define | SDL_BUTTON_MASK(X)
#define | SDL_BUTTON_LMASK SDL_BUTTON_MASK(SDL_BUTTON_LEFT)
#define | SDL_BUTTON_MMASK SDL_BUTTON_MASK(SDL_BUTTON_MIDDLE)
#define | SDL_BUTTON_RMASK SDL_BUTTON_MASK(SDL_BUTTON_RIGHT)
#define | SDL_BUTTON_X1MASK SDL_BUTTON_MASK(SDL_BUTTON_X1)
#define | SDL_BUTTON_X2MASK SDL_BUTTON_MASK(SDL_BUTTON_X2)

## Typedefs

typedef Uint32 | SDL_MouseID
typedef struct SDL_Cursor | SDL_Cursor
typedef Uint32 | SDL_MouseButtonFlags
typedef void(* | SDL_MouseMotionTransformCallback) (void *userdata, Uint64 timestamp, SDL_Window *window, SDL_MouseID mouseID, float *x, float *y)

## Enumerations

enum

SDL_SystemCursor {
SDL_SYSTEM_CURSOR_DEFAULT ,
SDL_SYSTEM_CURSOR_TEXT ,
SDL_SYSTEM_CURSOR_WAIT ,
SDL_SYSTEM_CURSOR_CROSSHAIR ,
SDL_SYSTEM_CURSOR_PROGRESS ,
SDL_SYSTEM_CURSOR_NWSE_RESIZE ,
SDL_SYSTEM_CURSOR_NESW_RESIZE ,
SDL_SYSTEM_CURSOR_EW_RESIZE ,
SDL_SYSTEM_CURSOR_NS_RESIZE ,
SDL_SYSTEM_CURSOR_MOVE ,
SDL_SYSTEM_CURSOR_NOT_ALLOWED ,
SDL_SYSTEM_CURSOR_POINTER ,
SDL_SYSTEM_CURSOR_NW_RESIZE ,
SDL_SYSTEM_CURSOR_N_RESIZE ,
SDL_SYSTEM_CURSOR_NE_RESIZE ,
SDL_SYSTEM_CURSOR_E_RESIZE ,
SDL_SYSTEM_CURSOR_SE_RESIZE ,
SDL_SYSTEM_CURSOR_S_RESIZE ,
SDL_SYSTEM_CURSOR_SW_RESIZE ,
SDL_SYSTEM_CURSOR_W_RESIZE ,
SDL_SYSTEM_CURSOR_COUNT
}

enum | SDL_MouseWheelDirection { SDL_MOUSEWHEEL_NORMAL , SDL_MOUSEWHEEL_FLIPPED }

## Functions

bool | SDL_HasMouse (void)
SDL_MouseID * | SDL_GetMice (int *count)
const char * | SDL_GetMouseNameForID (SDL_MouseID instance_id)
SDL_Window * | SDL_GetMouseFocus (void)
SDL_MouseButtonFlags | SDL_GetMouseState (float *x, float *y)
SDL_MouseButtonFlags | SDL_GetGlobalMouseState (float *x, float *y)
SDL_MouseButtonFlags | SDL_GetRelativeMouseState (float *x, float *y)
void | SDL_WarpMouseInWindow (SDL_Window *window, float x, float y)
bool | SDL_WarpMouseGlobal (float x, float y)
bool | SDL_SetRelativeMouseTransform (SDL_MouseMotionTransformCallback callback, void *userdata)
bool | SDL_SetWindowRelativeMouseMode (SDL_Window *window, bool enabled)
bool | SDL_GetWindowRelativeMouseMode (SDL_Window *window)
bool | SDL_CaptureMouse (bool enabled)
SDL_Cursor * | SDL_CreateCursor (const Uint8 *data, const Uint8 *mask, int w, int h, int hot_x, int hot_y)
SDL_Cursor * | SDL_CreateColorCursor (SDL_Surface *surface, int hot_x, int hot_y)
SDL_Cursor * | SDL_CreateAnimatedCursor (SDL_CursorFrameInfo *frames, int frame_count, int hot_x, int hot_y)
SDL_Cursor * | SDL_CreateSystemCursor (SDL_SystemCursor id)
bool | SDL_SetCursor (SDL_Cursor *cursor)
SDL_Cursor * | SDL_GetCursor (void)
SDL_Cursor * | SDL_GetDefaultCursor (void)
void | SDL_DestroyCursor (SDL_Cursor *cursor)
bool | SDL_ShowCursor (void)
bool | SDL_HideCursor (void)
bool | SDL_CursorVisible (void)

## Macro Definition Documentation

## SDL_BUTTON_LEFT

#define SDL_BUTTON_LEFT 1

Definition at line 161 of file SDL_mouse.h.

## SDL_BUTTON_LMASK

#define SDL_BUTTON_LMASK SDL_BUTTON_MASK(SDL_BUTTON_LEFT)

Definition at line 168 of file SDL_mouse.h.

## SDL_BUTTON_MASK

#define SDL_BUTTON_MASK | ( |  | X | ) |

Value:
(1u << ((X)-1))

Definition at line 167 of file SDL_mouse.h.

## SDL_BUTTON_MIDDLE

#define SDL_BUTTON_MIDDLE 2

Definition at line 162 of file SDL_mouse.h.

## SDL_BUTTON_MMASK

#define SDL_BUTTON_MMASK SDL_BUTTON_MASK(SDL_BUTTON_MIDDLE)

Definition at line 169 of file SDL_mouse.h.

## SDL_BUTTON_RIGHT

#define SDL_BUTTON_RIGHT 3

Definition at line 163 of file SDL_mouse.h.

## SDL_BUTTON_RMASK

#define SDL_BUTTON_RMASK SDL_BUTTON_MASK(SDL_BUTTON_RIGHT)

Definition at line 170 of file SDL_mouse.h.

## SDL_BUTTON_X1

#define SDL_BUTTON_X1 4

Definition at line 164 of file SDL_mouse.h.

## SDL_BUTTON_X1MASK

#define SDL_BUTTON_X1MASK SDL_BUTTON_MASK(SDL_BUTTON_X1)

Definition at line 171 of file SDL_mouse.h.

## SDL_BUTTON_X2

#define SDL_BUTTON_X2 5

Definition at line 165 of file SDL_mouse.h.

## SDL_BUTTON_X2MASK

#define SDL_BUTTON_X2MASK SDL_BUTTON_MASK(SDL_BUTTON_X2)

Definition at line 172 of file SDL_mouse.h.

## Typedef Documentation

## SDL_Cursor

typedef struct SDL_Cursor SDL_Cursor

The structure used to identify an SDL cursor.

This is opaque data.

Since
  This struct is available since SDL 3.2.0.

Definition at line 90 of file SDL_mouse.h.

## SDL_MouseButtonFlags

typedef Uint32 SDL_MouseButtonFlags

A bitmask of pressed mouse buttons, as reported by SDL_GetMouseState, etc.

- Button 1: Left mouse button
- Button 2: Middle mouse button
- Button 3: Right mouse button
- Button 4: Side mouse button 1
- Button 5: Side mouse button 2

Since
  This datatype is available since SDL 3.2.0.

See also
  SDL_GetMouseState
  SDL_GetGlobalMouseState
  SDL_GetRelativeMouseState

Definition at line 159 of file SDL_mouse.h.

## SDL_MouseID

typedef Uint32 SDL_MouseID

# CategoryMouse

Any GUI application has to deal with the mouse, and SDL provides functions to manage mouse input and the displayed cursor.

Most interactions with the mouse will come through the event subsystem. Moving a mouse generates an SDL_EVENT_MOUSE_MOTION event, pushing a button generates SDL_EVENT_MOUSE_BUTTON_DOWN, etc, but one can also query the current state of the mouse at any time with SDL_GetMouseState().

For certain games, it's useful to disassociate the mouse cursor from mouse input. An FPS, for example, would not want the player's motion to stop as the mouse hits the edge of the window. For these scenarios, use SDL_SetWindowRelativeMouseMode(), which hides the cursor, grabs mouse input to the window, and reads mouse input no matter how far it moves.

Games that want the system to track the mouse but want to draw their own cursor can use SDL_HideCursor() and SDL_ShowCursor(). It might be more efficient to let the system manage the cursor, if possible, using SDL_SetCursor() with a custom image made through SDL_CreateColorCursor(), or perhaps just a specific system cursor from SDL_CreateSystemCursor().

SDL can, on many platforms, differentiate between multiple connected mice, allowing for interesting input scenarios and multiplayer games. They can be enumerated with SDL_GetMice(), and SDL will send SDL_EVENT_MOUSE_ADDED and SDL_EVENT_MOUSE_REMOVED events as they are connected and unplugged.

Since many apps only care about basic mouse input, SDL offers a virtual mouse device for touch and pen input, which often can make a desktop application work on a touchscreen phone without any code changes. Apps that care about touch/pen separately from mouse input should filter out events with a which field of SDL_TOUCH_MOUSEID/SDL_PEN_MOUSEID. This is a unique ID for a mouse for the time it is connected to the system, and is never reused for the lifetime of the application.

If the mouse is disconnected and reconnected, it will get a new ID.

The value 0 is an invalid ID.

Since
  This datatype is available since SDL 3.2.0.

Definition at line 81 of file SDL_mouse.h.

## SDL_MouseMotionTransformCallback

typedef void(* SDL_MouseMotionTransformCallback) (void *userdata, Uint64 timestamp, SDL_Window *window, SDL_MouseID mouseID, float *x, float *y)

A callback used to transform mouse motion delta from raw values.

This is called during SDL's handling of platform mouse events to scale the values of the resulting motion delta.

Parameters

  userdata | what was passed as userdata to SDL_SetRelativeMouseTransform().
  timestamp | the associated time at which this mouse motion event was received.
  window | the associated window to which this mouse motion event was addressed.
  mouseID | the associated mouse from which this mouse motion event was emitted.
  x | pointer to a variable that will be treated as the resulting x-axis motion.
  y | pointer to a variable that will be treated as the resulting y-axis motion.

\threadsafety This callback is called by SDL's internal mouse input processing procedure, which may be a thread separate from the main event loop that is run at realtime priority. Stalling this thread with too much work in the callback can therefore potentially freeze the entire system. Care should be taken with proper synchronization practices when adding other side effects beyond mutation of the x and y values.

Since
  This datatype is available since SDL 3.4.0.

See also
  SDL_SetRelativeMouseTransform

Definition at line 205 of file SDL_mouse.h.

## Enumeration Type Documentation

## SDL_MouseWheelDirection

enum SDL_MouseWheelDirection

Scroll direction types for the Scroll event

Since
  This enum is available since SDL 3.2.0.

Enumerator
SDL_MOUSEWHEEL_NORMAL | The scroll direction is normal
SDL_MOUSEWHEEL_FLIPPED | The scroll direction is flipped / natural

Definition at line 127 of file SDL_mouse.h.

{
SDL_MOUSEWHEEL_NORMAL, /**< The scroll direction is normal */
SDL_MOUSEWHEEL_FLIPPED /**< The scroll direction is flipped / natural */
} SDL_MouseWheelDirection;
SDL_MouseWheelDirection
SDL_MouseWheelDirection
Definition SDL_mouse.h:128
SDL_MOUSEWHEEL_NORMAL
@ SDL_MOUSEWHEEL_NORMAL
Definition SDL_mouse.h:129
SDL_MOUSEWHEEL_FLIPPED
@ SDL_MOUSEWHEEL_FLIPPED
Definition SDL_mouse.h:130

## SDL_SystemCursor

enum SDL_SystemCursor

Cursor types for SDL_CreateSystemCursor().

Since
  This enum is available since SDL 3.2.0.

Enumerator
SDL_SYSTEM_CURSOR_DEFAULT | Default cursor. Usually an arrow.
SDL_SYSTEM_CURSOR_TEXT | Text selection. Usually an I-beam.
SDL_SYSTEM_CURSOR_WAIT | Wait. Usually an hourglass or watch or spinning ball.
SDL_SYSTEM_CURSOR_CROSSHAIR | Crosshair.
SDL_SYSTEM_CURSOR_PROGRESS | Program is busy but still interactive. Usually it's WAIT with an arrow.
SDL_SYSTEM_CURSOR_NWSE_RESIZE | Double arrow pointing northwest and southeast.
SDL_SYSTEM_CURSOR_NESW_RESIZE | Double arrow pointing northeast and southwest.
SDL_SYSTEM_CURSOR_EW_RESIZE | Double arrow pointing west and east.
SDL_SYSTEM_CURSOR_NS_RESIZE | Double arrow pointing north and south.
SDL_SYSTEM_CURSOR_MOVE | Four pointed arrow pointing north, south, east, and west.
SDL_SYSTEM_CURSOR_NOT_ALLOWED | Not permitted. Usually a slashed circle or crossbones.
SDL_SYSTEM_CURSOR_POINTER | Pointer that indicates a link. Usually a pointing hand.
SDL_SYSTEM_CURSOR_NW_RESIZE | Window resize top-left. This may be a single arrow or a double arrow like NWSE_RESIZE.
SDL_SYSTEM_CURSOR_N_RESIZE | Window resize top. May be NS_RESIZE.
SDL_SYSTEM_CURSOR_NE_RESIZE | Window resize top-right. May be NESW_RESIZE.
SDL_SYSTEM_CURSOR_E_RESIZE | Window resize right. May be EW_RESIZE.
SDL_SYSTEM_CURSOR_SE_RESIZE | Window resize bottom-right. May be NWSE_RESIZE.
SDL_SYSTEM_CURSOR_S_RESIZE | Window resize bottom. May be NS_RESIZE.
SDL_SYSTEM_CURSOR_SW_RESIZE | Window resize bottom-left. May be NESW_RESIZE.
SDL_SYSTEM_CURSOR_W_RESIZE | Window resize left. May be EW_RESIZE.
SDL_SYSTEM_CURSOR_COUNT |

Definition at line 97 of file SDL_mouse.h.

{
SDL_SYSTEM_CURSOR_DEFAULT, /**< Default cursor. Usually an arrow. */
SDL_SYSTEM_CURSOR_TEXT, /**< Text selection. Usually an I-beam. */
SDL_SYSTEM_CURSOR_WAIT, /**< Wait. Usually an hourglass or watch or spinning ball. */
SDL_SYSTEM_CURSOR_CROSSHAIR, /**< Crosshair. */
SDL_SYSTEM_CURSOR_PROGRESS, /**< Program is busy but still interactive. Usually it's WAIT with an arrow. */
SDL_SYSTEM_CURSOR_NWSE_RESIZE, /**< Double arrow pointing northwest and southeast. */
SDL_SYSTEM_CURSOR_NESW_RESIZE, /**< Double arrow pointing northeast and southwest. */
SDL_SYSTEM_CURSOR_EW_RESIZE, /**< Double arrow pointing west and east. */
SDL_SYSTEM_CURSOR_NS_RESIZE, /**< Double arrow pointing north and south. */
SDL_SYSTEM_CURSOR_MOVE, /**< Four pointed arrow pointing north, south, east, and west. */
SDL_SYSTEM_CURSOR_NOT_ALLOWED, /**< Not permitted. Usually a slashed circle or crossbones. */
SDL_SYSTEM_CURSOR_POINTER, /**< Pointer that indicates a link. Usually a pointing hand. */
SDL_SYSTEM_CURSOR_NW_RESIZE, /**< Window resize top-left. This may be a single arrow or a double arrow like NWSE_RESIZE. */
SDL_SYSTEM_CURSOR_N_RESIZE, /**< Window resize top. May be NS_RESIZE. */
SDL_SYSTEM_CURSOR_NE_RESIZE, /**< Window resize top-right. May be NESW_RESIZE. */
SDL_SYSTEM_CURSOR_E_RESIZE, /**< Window resize right. May be EW_RESIZE. */
SDL_SYSTEM_CURSOR_SE_RESIZE, /**< Window resize bottom-right. May be NWSE_RESIZE. */
SDL_SYSTEM_CURSOR_S_RESIZE, /**< Window resize bottom. May be NS_RESIZE. */
SDL_SYSTEM_CURSOR_SW_RESIZE, /**< Window resize bottom-left. May be NESW_RESIZE. */
SDL_SYSTEM_CURSOR_W_RESIZE, /**< Window resize left. May be EW_RESIZE. */
SDL_SYSTEM_CURSOR_COUNT
} SDL_SystemCursor;
SDL_SystemCursor
SDL_SystemCursor
Definition SDL_mouse.h:98
SDL_SYSTEM_CURSOR_NWSE_RESIZE
@ SDL_SYSTEM_CURSOR_NWSE_RESIZE
Definition SDL_mouse.h:104
SDL_SYSTEM_CURSOR_POINTER
@ SDL_SYSTEM_CURSOR_POINTER
Definition SDL_mouse.h:110
SDL_SYSTEM_CURSOR_EW_RESIZE
@ SDL_SYSTEM_CURSOR_EW_RESIZE
Definition SDL_mouse.h:106
SDL_SYSTEM_CURSOR_SE_RESIZE
@ SDL_SYSTEM_CURSOR_SE_RESIZE
Definition SDL_mouse.h:115
SDL_SYSTEM_CURSOR_NS_RESIZE
@ SDL_SYSTEM_CURSOR_NS_RESIZE
Definition SDL_mouse.h:107
SDL_SYSTEM_CURSOR_N_RESIZE
@ SDL_SYSTEM_CURSOR_N_RESIZE
Definition SDL_mouse.h:112
SDL_SYSTEM_CURSOR_E_RESIZE
@ SDL_SYSTEM_CURSOR_E_RESIZE
Definition SDL_mouse.h:114
SDL_SYSTEM_CURSOR_MOVE
@ SDL_SYSTEM_CURSOR_MOVE
Definition SDL_mouse.h:108
SDL_SYSTEM_CURSOR_NE_RESIZE
@ SDL_SYSTEM_CURSOR_NE_RESIZE
Definition SDL_mouse.h:113
SDL_SYSTEM_CURSOR_DEFAULT
@ SDL_SYSTEM_CURSOR_DEFAULT
Definition SDL_mouse.h:99
SDL_SYSTEM_CURSOR_NESW_RESIZE
@ SDL_SYSTEM_CURSOR_NESW_RESIZE
Definition SDL_mouse.h:105
SDL_SYSTEM_CURSOR_TEXT
@ SDL_SYSTEM_CURSOR_TEXT
Definition SDL_mouse.h:100
SDL_SYSTEM_CURSOR_COUNT
@ SDL_SYSTEM_CURSOR_COUNT
Definition SDL_mouse.h:119
SDL_SYSTEM_CURSOR_W_RESIZE
@ SDL_SYSTEM_CURSOR_W_RESIZE
Definition SDL_mouse.h:118
SDL_SYSTEM_CURSOR_WAIT
@ SDL_SYSTEM_CURSOR_WAIT
Definition SDL_mouse.h:101
SDL_SYSTEM_CURSOR_SW_RESIZE
@ SDL_SYSTEM_CURSOR_SW_RESIZE
Definition SDL_mouse.h:117
SDL_SYSTEM_CURSOR_S_RESIZE
@ SDL_SYSTEM_CURSOR_S_RESIZE
Definition SDL_mouse.h:116
SDL_SYSTEM_CURSOR_NW_RESIZE
@ SDL_SYSTEM_CURSOR_NW_RESIZE
Definition SDL_mouse.h:111
SDL_SYSTEM_CURSOR_NOT_ALLOWED
@ SDL_SYSTEM_CURSOR_NOT_ALLOWED
Definition SDL_mouse.h:109
SDL_SYSTEM_CURSOR_CROSSHAIR
@ SDL_SYSTEM_CURSOR_CROSSHAIR
Definition SDL_mouse.h:102
SDL_SYSTEM_CURSOR_PROGRESS
@ SDL_SYSTEM_CURSOR_PROGRESS
Definition SDL_mouse.h:103

## Function Documentation

## SDL_CaptureMouse()

bool SDL_CaptureMouse | ( | bool | enabled | ) |

extern

Capture the mouse and to track input outside an SDL window.

Capturing enables your app to obtain mouse events globally, instead of just within your window. Not all video targets support this function. When capturing is enabled, the current window will get all mouse events, but unlike relative mode, no change is made to the cursor and it is not restrained to your window.

This function may also deny mouse input to other windows–both those in your application and others on the system–so you should use this function sparingly, and in small bursts. For example, you might want to track the mouse while the user is dragging something, until the user releases a mouse button. It is not recommended that you capture the mouse for long periods of time, such as the entire time your app is running. For that, you should probably use SDL_SetWindowRelativeMouseMode() or SDL_SetWindowMouseGrab(), depending on your goals.

While captured, mouse events still report coordinates relative to the current (foreground) window, but those coordinates may be outside the bounds of the window (including negative values). Capturing is only allowed for the foreground window. If the window loses focus while capturing, the capture will be disabled automatically.

While capturing is enabled, the current window will have the SDL_WINDOW_MOUSE_CAPTURE flag set.

Please note that SDL will attempt to "auto capture" the mouse while the user is pressing a button; this is to try and make mouse behavior more consistent between platforms, and deal with the common case of a user dragging the mouse outside of the window. This means that if you are calling SDL_CaptureMouse() only to deal with this situation, you do not have to (although it is safe to do so). If this causes problems for your app, you can disable auto capture by setting the SDL_HINT_MOUSE_AUTO_CAPTURE hint to zero.

Parameters

  enabled | true to enable capturing, false to disable.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGlobalMouseState

## SDL_CreateAnimatedCursor()

SDL_Cursor * SDL_CreateAnimatedCursor | ( | SDL_CursorFrameInfo * | frames,
|  | int | frame_count,
|  | int | hot_x,
|  | int | hot_y )

extern

Create an animated color cursor.

Animated cursors are composed of a sequential array of frames, specified as surfaces and durations in an array of SDL_CursorFrameInfo structs. The hot spot coordinates are universal to all frames, and all frames must have the same dimensions.

Frame durations are specified in milliseconds. A duration of 0 implies an infinite frame time, and the animation will stop on that frame. To create a one-shot animation, set the duration of the last frame in the sequence to 0.

If this function is passed surfaces with alternate representations added with SDL_AddSurfaceAlternateImage(), the surfaces will be interpreted as the content to be used for 100% display scale, and the alternate representations will be used for high DPI situations. For example, if the original surfaces are 32x32, then on a 2x macOS display or 200% display scale on Windows, a 64x64 version of the image will be used, if available. If a matching version of the image isn't available, the closest larger size image will be downscaled to the appropriate size and be used instead, if available. Otherwise, the closest smaller image will be upscaled and be used instead.

If the underlying platform does not support animated cursors, this function will fall back to creating a static color cursor using the first frame in the sequence.

Parameters

  frames | an array of cursor images composing the animation.
  frame_count | the number of frames in the sequence.
  hot_x | the x position of the cursor hot spot.
  hot_y | the y position of the cursor hot spot.

Returns
  the new cursor on success or NULL on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.4.0.

See also
  SDL_AddSurfaceAlternateImage
  SDL_CreateCursor
  SDL_CreateColorCursor
  SDL_CreateSystemCursor
  SDL_DestroyCursor
  SDL_SetCursor

## SDL_CreateColorCursor()

SDL_Cursor * SDL_CreateColorCursor | ( | SDL_Surface * | surface,
|  | int | hot_x,
|  | int | hot_y )

extern

Create a color cursor.

If this function is passed a surface with alternate representations added with SDL_AddSurfaceAlternateImage(), the surface will be interpreted as the content to be used for 100% display scale, and the alternate representations will be used for high DPI situations if SDL_HINT_MOUSE_DPI_SCALE_CURSORS is enabled. For example, if the original surface is 32x32, then on a 2x macOS display or 200% display scale on Windows, a 64x64 version of the image will be used, if available. If a matching version of the image isn't available, the closest larger size image will be downscaled to the appropriate size and be used instead, if available. Otherwise, the closest smaller image will be upscaled and be used instead.

Parameters

  surface | an SDL_Surface structure representing the cursor image.
  hot_x | the x position of the cursor hot spot.
  hot_y | the y position of the cursor hot spot.

Returns
  the new cursor on success or NULL on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_AddSurfaceAlternateImage
  SDL_CreateAnimatedCursor
  SDL_CreateCursor
  SDL_CreateSystemCursor
  SDL_DestroyCursor
  SDL_SetCursor

## SDL_CreateCursor()

SDL_Cursor * SDL_CreateCursor | ( | const Uint8 * | data,
|  | const Uint8 * | mask,
|  | int | w,
|  | int | h,
|  | int | hot_x,
|  | int | hot_y )

extern

Create a cursor using the specified bitmap data and mask (in MSB format).

mask has to be in MSB (Most Significant Bit) format.

The cursor width (w) must be a multiple of 8 bits.

The cursor is created in black and white according to the following:

- data=0, mask=1: white
- data=1, mask=1: black
- data=0, mask=0: transparent
- data=1, mask=0: inverted color if possible, black if not.

Cursors created with this function must be freed with SDL_DestroyCursor().

If you want to have a color cursor, or create your cursor from an SDL_Surface, you should use SDL_CreateColorCursor(). Alternately, you can hide the cursor and draw your own as part of your game's rendering, but it will be bound to the framerate.

Also, SDL_CreateSystemCursor() is available, which provides several readily-available system cursors to pick from.

Parameters

  data | the color value for each pixel of the cursor.
  mask | the mask value for each pixel of the cursor.
  w | the width of the cursor.
  h | the height of the cursor.
  hot_x | the x-axis offset from the left of the cursor image to the mouse x position, in the range of 0 to w - 1.
  hot_y | the y-axis offset from the top of the cursor image to the mouse y position, in the range of 0 to h - 1.

Returns
  a new cursor with the specified parameters on success or NULL on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateAnimatedCursor
  SDL_CreateColorCursor
  SDL_CreateSystemCursor
  SDL_DestroyCursor
  SDL_SetCursor

## SDL_CreateSystemCursor()

SDL_Cursor * SDL_CreateSystemCursor | ( | SDL_SystemCursor | id | ) |

extern

Create a system cursor.

Parameters

  id | an SDL_SystemCursor enum value.

Returns
  a cursor on success or NULL on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_DestroyCursor

## SDL_CursorVisible()

bool SDL_CursorVisible | ( | void |  | ) |

extern

Return whether the cursor is currently being shown.

Returns
  true if the cursor is being shown, or false if the cursor is hidden.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HideCursor
  SDL_ShowCursor

## SDL_DestroyCursor()

void SDL_DestroyCursor | ( | SDL_Cursor * | cursor | ) |

extern

Free a previously-created cursor.

Use this function to free cursor resources created with SDL_CreateCursor(), SDL_CreateColorCursor() or SDL_CreateSystemCursor().

Parameters

  cursor | the cursor to free.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateAnimatedCursor
  SDL_CreateColorCursor
  SDL_CreateCursor
  SDL_CreateSystemCursor

## SDL_GetCursor()

SDL_Cursor * SDL_GetCursor | ( | void |  | ) |

extern

Get the active cursor.

This function returns a pointer to the current cursor which is owned by the library. It is not necessary to free the cursor with SDL_DestroyCursor().

Returns
  the active cursor or NULL if there is no mouse.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetCursor

## SDL_GetDefaultCursor()

SDL_Cursor * SDL_GetDefaultCursor | ( | void |  | ) |

extern

Get the default cursor.

You do not have to call SDL_DestroyCursor() on the return value, but it is safe to do so.

Returns
  the default cursor on success or NULL on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGlobalMouseState()

SDL_MouseButtonFlags SDL_GetGlobalMouseState | ( | float * | x,
|  | float * | y )

extern

Query the platform for the asynchronous mouse button state and the desktop-relative platform-cursor position.

This function immediately queries the platform for the most recent asynchronous state, more costly than retrieving SDL's cached state in SDL_GetMouseState().

Passing non-NULL pointers to x or y will write the destination with respective x or y coordinates relative to the desktop.

In Relative Mode, the platform-cursor's position usually contradicts the SDL-cursor's position as manually calculated from SDL_GetMouseState() and SDL_GetWindowPosition.

This function can be useful if you need to track the mouse outside of a specific window and SDL_CaptureMouse() doesn't fit your needs. For example, it could be useful if you need to track the mouse while dragging a window, where coordinates relative to a window might not be in sync at all times.

Parameters

  x | a pointer to receive the platform-cursor's x-position from the desktop's top left corner, can be NULL if unused.
  y | a pointer to receive the platform-cursor's y-position from the desktop's top left corner, can be NULL if unused.

Returns
  a 32-bit bitmask of the button state that can be bitwise-compared against the SDL_BUTTON_MASK(X) macro.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CaptureMouse
  SDL_GetMouseState
  SDL_GetGlobalMouseState

## SDL_GetMice()

SDL_MouseID * SDL_GetMice | ( | int * | count | ) |

extern

Get a list of currently connected mice.

Note that this will include any device or virtual driver that includes mouse functionality, including some game controllers, KVM switches, etc. You should wait for input from a device before you consider it actively in use.

Parameters

  count | a pointer filled in with the number of mice returned, may be NULL.

Returns
  a 0 terminated array of mouse instance IDs or NULL on failure; call SDL_GetError() for more information. This should be freed with SDL_free() when it is no longer needed.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetMouseNameForID
  SDL_HasMouse

## SDL_GetMouseFocus()

SDL_Window * SDL_GetMouseFocus | ( | void |  | ) |

extern

Get the window which currently has mouse focus.

Returns
  the window with mouse focus.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetMouseNameForID()

const char * SDL_GetMouseNameForID | ( | SDL_MouseID | instance_id | ) |

extern

Get the name of a mouse.

This function returns "" if the mouse doesn't have a name.

Parameters

  instance_id | the mouse instance ID.

Returns
  the name of the selected mouse, or NULL on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetMice

## SDL_GetMouseState()

SDL_MouseButtonFlags SDL_GetMouseState | ( | float * | x,
|  | float * | y )

extern

Query SDL's cache for the synchronous mouse button state and the window-relative SDL-cursor position.

This function returns the cached synchronous state as SDL understands it from the last pump of the event queue.

To query the platform for immediate asynchronous state, use SDL_GetGlobalMouseState.

Passing non-NULL pointers to x or y will write the destination with respective x or y coordinates relative to the focused window.

In Relative Mode, the SDL-cursor's position usually contradicts the platform-cursor's position as manually calculated from SDL_GetGlobalMouseState() and SDL_GetWindowPosition.

Parameters

  x | a pointer to receive the SDL-cursor's x-position from the focused window's top left corner, can be NULL if unused.
  y | a pointer to receive the SDL-cursor's y-position from the focused window's top left corner, can be NULL if unused.

Returns
  a 32-bit bitmask of the button state that can be bitwise-compared against the SDL_BUTTON_MASK(X) macro.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGlobalMouseState
  SDL_GetRelativeMouseState

## SDL_GetRelativeMouseState()

SDL_MouseButtonFlags SDL_GetRelativeMouseState | ( | float * | x,
|  | float * | y )

extern

Query SDL's cache for the synchronous mouse button state and accumulated mouse delta since last call.

This function returns the cached synchronous state as SDL understands it from the last pump of the event queue.

To query the platform for immediate asynchronous state, use SDL_GetGlobalMouseState.

Passing non-NULL pointers to x or y will write the destination with respective x or y deltas accumulated since the last call to this function (or since event initialization).

This function is useful for reducing overhead by processing relative mouse inputs in one go per-frame instead of individually per-event, at the expense of losing the order between events within the frame (e.g. quickly pressing and releasing a button within the same frame).

Parameters

  x | a pointer to receive the x mouse delta accumulated since last call, can be NULL if unused.
  y | a pointer to receive the y mouse delta accumulated since last call, can be NULL if unused.

Returns
  a 32-bit bitmask of the button state that can be bitwise-compared against the SDL_BUTTON_MASK(X) macro.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetMouseState
  SDL_GetGlobalMouseState

## SDL_GetWindowRelativeMouseMode()

bool SDL_GetWindowRelativeMouseMode | ( | SDL_Window * | window | ) |

extern

Query whether relative mouse mode is enabled for a window.

Parameters

  window | the window to query.

Returns
  true if relative mode is enabled for a window or false otherwise.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetWindowRelativeMouseMode

References window.

## SDL_HasMouse()

bool SDL_HasMouse | ( | void |  | ) |

extern

Return whether a mouse is currently connected.

Returns
  true if a mouse is connected, false otherwise.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetMice

## SDL_HideCursor()

bool SDL_HideCursor | ( | void |  | ) |

extern

Hide the cursor.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CursorVisible
  SDL_ShowCursor

## SDL_SetCursor()

bool SDL_SetCursor | ( | SDL_Cursor * | cursor | ) |

extern

Set the active cursor.

This function sets the currently active cursor to the specified one. If the cursor is currently visible, the change will be immediately represented on the display. SDL_SetCursor(NULL) can be used to force cursor redraw, if this is desired for any reason.

Parameters

  cursor | a cursor to make active.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetCursor

## SDL_SetRelativeMouseTransform()

bool SDL_SetRelativeMouseTransform | ( | SDL_MouseMotionTransformCallback | callback,
|  | void * | userdata )

extern

Set a user-defined function by which to transform relative mouse inputs.

This overrides the relative system scale and relative speed scale hints. Should be called prior to enabling relative mouse mode, fails otherwise.

Parameters

  callback | a callback used to transform relative mouse motion, or NULL for default behavior.
  userdata | a pointer that will be passed to callback.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.4.0.

## SDL_SetWindowRelativeMouseMode()

bool SDL_SetWindowRelativeMouseMode | ( | SDL_Window * | window,
|  | bool | enabled )

extern

Set relative mouse mode for a window.

While the window has focus and relative mouse mode is enabled, the cursor is hidden, the mouse position is constrained to the window, and SDL will report continuous relative mouse motion even if the mouse is at the edge of the window.

If you'd like to keep the mouse position fixed while in relative mode you can use SDL_SetWindowMouseRect(). If you'd like the cursor to be at a specific location when relative mode ends, you should use SDL_WarpMouseInWindow() before disabling relative mode.

This function will flush any pending mouse motion for this window.

Parameters

  window | the window to change.
  enabled | true to enable relative mode, false to disable.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetWindowRelativeMouseMode

References window.

## SDL_ShowCursor()

bool SDL_ShowCursor | ( | void |  | ) |

extern

Show the cursor.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CursorVisible
  SDL_HideCursor

## SDL_WarpMouseGlobal()

bool SDL_WarpMouseGlobal | ( | float | x,
|  | float | y )

extern

Move the mouse to the given position in global screen space.

This function generates a mouse motion event.

A failure of this function usually means that it is unsupported by a platform.

Note that this function will appear to succeed, but not actually move the mouse when used over Microsoft Remote Desktop.

Parameters

  x | the x coordinate.
  y | the y coordinate.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_WarpMouseInWindow

## SDL_WarpMouseInWindow()

void SDL_WarpMouseInWindow | ( | SDL_Window * | window,
|  | float | x,
|  | float | y )

extern

Move the mouse cursor to the given position within the window.

This function generates a mouse motion event if relative mode is not enabled. If relative mode is enabled, you can force mouse events for the warp by setting the SDL_HINT_MOUSE_RELATIVE_WARP_MOTION hint.

Note that this function will appear to succeed, but not actually move the mouse when used over Microsoft Remote Desktop.

Parameters

  window | the window to move the mouse into, or NULL for the current mouse focus.
  x | the x coordinate within the window.
  y | the y coordinate within the window.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_WarpMouseGlobal

References window.